<template>
  <div
    class="conversation-card"
    :class="{ unread: isUnreadLastMessage, active: active }"
  >
    <slot name="avatar" />
    <div class="conversation-content">
      <div class="conversation-card-top">
        <ConversationName
          :chat="chat"
          :active="isUnreadLastMessage"
          class="conversation-title"
        />
        <div class="conversation-last-message-time">
          <JText
            type="text-3"
            color="text"
            :weight="isUnreadLastMessage ? 'bold' : 'normal'"
          >
            <MessageTime
              v-if="chat.lastMessage"
              :message="chat.lastMessage"
              hide-updated-label
            />
          </JText>
        </div>
      </div>
      <div
        v-if="isShowLastDefaultMessage"
        class="conversation-last-message text-ellipsis"
      >
        <template v-if="userTypingMessage && active === false">
          <JText
            v-if="isGroupChat"
            type="text-2"
            color="secondary-title"
            :weight="getWeightText"
            class="last-message-author"
          >
            {{ userTypingMessage.name }}:
          </JText>
          <JTypingDots />
        </template>
        <template v-else>
          <JText
            v-if="isGroupChat && chat.lastMessage?.author.name"
            type="text-2"
            color="secondary-title"
            :weight="getWeightText"
            class="last-message-author"
          >
            {{ lastMessageAuthor }}:
          </JText>
          <JText
            v-if="isGroupChat === false && chat.lastMessage?.author.id === getUser?.id"
            type="text-2"
            color="secondary-title"
            :weight="getWeightText"
            class="last-message-author"
          >
            {{ $t('you') }}:
          </JText>
          <JText
            tag="div"
            type="text-2"
            :weight="getWeightText"
            color="secondary-title"
          >
            <DeletedMessage
              v-if="chat.lastMessage?.deletedDate"
              hide-restore-btn
            />
            <template v-else>
              {{ chat.lastMessage?.shortContent }}
            </template>
          </JText>
        </template>
      </div>
      <div
        v-else-if="isShowLastCallMessage && chat.lastMessage"
        class="conversation-last-message text-ellipsis"
      >
        <ConversationCallMessages
          :message="chat.lastMessage"
          :weight-text="getWeightText"
        />
      </div>
      <JText
        v-else-if="chat.lastMessage?.type === MessageTypes.CreateGroup"
        type="text-2"
        :weight="getWeightText"
        color="secondary-title"
        class="call-message"
      >
        <SystemMessage> Group created </SystemMessage>
      </JText>
      <JText
        v-else-if="chat.lastMessage?.type === MessageTypes.LeaveGroup"
        type="text-2"
        :weight="getWeightText"
        color="secondary-title"
        class="call-message"
      >
        <SystemMessage> User leave group </SystemMessage>
      </JText>
    </div>
  </div>
</template>

<script setup lang="ts">
import { PropType, computed, inject } from 'vue';
import { storeToRefs } from 'pinia';
import { i18n } from '@new-jira-clone/libs/src/types';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { JTypingDots, JText } from '@new-jira-clone/ui/src/components';
import computedEager from '@new-jira-clone/ui/src/composables/utils/useComputedEager';
import { MessageTime, DeletedMessage } from '@/entities/Message';
import {
  ChatTypes, IChat, IUser, MessageTypes, SystemMessage,
} from '@/shared';
import ConversationName from './ConversationName.vue';
import ConversationCallMessages from './ConversationCallMessages.vue';

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
  active: {
    type: Boolean,
    default: false,
  },
  isUnreadLastMessage: {
    type: Boolean,
    default: false,
  },
  userTypingMessage: {
    type: Object as PropType<IUser>,
    default: null,
  },
});

const $t = inject('$t') as i18n;

const { getUser } = storeToRefs(useUserStore());

const lastMessageAuthor = computedEager(() => {
  if (props.chat.lastMessage?.author.id === getUser.value?.id) {
    return $t('you');
  }

  return props.chat.lastMessage?.author.name;
});

const isGroupChat = computed(() => props.chat.type === ChatTypes.Group);

const getWeightText = computed(() => (props.isUnreadLastMessage ? 'bold' : 'normal'));

const isShowLastCallMessage = computed(() => {
  if (props.chat.lastMessage?.type === MessageTypes.EndCall) return true;
  if (props.chat.lastMessage?.type === MessageTypes.CallOffer) return true;

  return false;
});

const isShowLastDefaultMessage = computed(() => {
  if (props.userTypingMessage && props.active === false) return true;
  if (props.chat.lastMessage?.shortContent) return true;

  return false;
});
</script>

<style scoped lang="scss">
@use '@tools' as uiTools;

.conversation-card {
  display: flex;
  align-items: center;
  position: relative;
  padding: 10px 16px;
  height: 65px;
  width: inherit;

  &.active {
    @include uiTools.active-color;

    &:not(.unread) {
      @include uiTools.vertical-bar;
    }
  }

  &.unread {
    &::after {
      content: '';
      position: absolute;
      top: calc(50% - 2px);
      left: 7px;
      width: 4px;
      height: 4px;
      background: #242424;
      border-radius: 50%;
      pointer-events: none;
    }
  }

  .last-message-author {
    margin-right: 6px;
  }

  .conversation-last-message {
    display: flex;
    margin-right: 32px;
    height: 22px;

    &:empty {
      min-height: 21px;
    }
  }

  .conversation-last-message-time {
    display: flex;
    align-items: flex-end;
    margin-left: 8px;
  }
}

.conversation-card-top {
  display: flex;
  justify-content: space-between;
}

.conversation-content {
  margin-left: 8px;
  width: calc(100% - 42px - 10px);
}

.canceled-call-message {
  font-style: italic;
}
</style>
